
// ModelViewerView.h : CModelViewerView NX̃C^[tFCX
//

#pragma once

#include "OpenGLPickView.h"
#include "Model.h"

class CModelViewerView : public COpenGLPickView
{
	// oϐ
private:
	BOOL m_bRotation;
	BOOL m_bPan;
	BOOL m_bZoom;
	BOOL m_bRenderPoint;
	BOOL m_bRenderLine;
	BOOL m_bRenderFace;
	BOOL m_bPickPoint;
	BOOL m_bPickLine;
	BOOL m_bPickFace;
	CModel m_model;
	GLubyte* m_abt4VertexIdColor;
	GLubyte* m_abt4TriangleIdColor;

	// o֐
private:
	void	DoTracking( CPoint point );
	bool	RenderScene();
	void	RenderModel( ERENDERMODE eRenderMode );
	void	IdentifyPickRegionPixels( unsigned int uiCountPickRegionPixel, unsigned int aauiNamePickRegionPixel[][NAMEARRAYSIZE] );
	void	MakeArray();
	void	DestroyArray();

protected: // VÂݍ쐬܂B
	CModelViewerView();
	DECLARE_DYNCREATE(CModelViewerView)

// 
public:
	CModelViewerDoc* GetDocument() const;

// 
public:

// I[o[Ch
public:
//	virtual void OnDraw(CDC* pDC);  // ̃r[`悷邽߂ɃI[o[Ch܂B
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
protected:

// 
public:
	virtual ~CModelViewerView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// ꂽAbZ[W蓖Ċ֐
protected:
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnViewRotation();
	afx_msg void OnViewPan();
	afx_msg void OnViewZoom();
	afx_msg void OnUpdateViewRotation( CCmdUI *pCmdUI );
	afx_msg void OnUpdateViewPan( CCmdUI *pCmdUI );
	afx_msg void OnUpdateViewZoom( CCmdUI *pCmdUI );
	afx_msg void OnViewRenderpoint();
	afx_msg void OnViewRenderline();
	afx_msg void OnViewRenderface();
	afx_msg void OnUpdateViewRenderpoint( CCmdUI *pCmdUI );
	afx_msg void OnUpdateViewRenderline( CCmdUI *pCmdUI );
	afx_msg void OnUpdateViewRenderface( CCmdUI *pCmdUI );
	afx_msg void OnViewPickpoint();
	afx_msg void OnViewPickline();
	afx_msg void OnViewPickface();
	afx_msg void OnUpdateViewPickpoint( CCmdUI *pCmdUI );
	afx_msg void OnUpdateViewPickline( CCmdUI *pCmdUI );
	afx_msg void OnUpdateViewPickface( CCmdUI *pCmdUI );
	afx_msg void OnFileOpen();
};

#ifndef _DEBUG  // ModelViewerView.cpp ̃fobO o[W
inline CModelViewerDoc* CModelViewerView::GetDocument() const
   { return reinterpret_cast<CModelViewerDoc*>(m_pDocument); }
#endif

